<template>
  <table>
    <thead>
      <tr v-if="hasFilter">
        <th :colspan="tableHeaders.length">
          <div class="display-flex">
            <filter-cell
              v-for="h in tableFilters"
              :config="h"
              :value="filters[h.field]"
              @input="onFilter(h.field, $event)"
            />
          </div>
        </th>
      </tr>
      <tr>
        <Header
          v-for="h in tableHeaders"
          :config="h"
          @click.prevent="sort(h)"
        />
      </tr>
    </thead>
    <tbody>
      <tr v-for="row in sorted">
        <slot name="row" v-bind:entry="row">
          <td v-for="h in tableHeaders">
            {{ row[h[0]] }}
          </td>
        </slot>
      </tr>
    </tbody>
    <tfoot>
      <tr>
        <Header
          v-for="h in tableHeaders"
          :config="h"
          @click.prevent="sort(h)"
        />
      </tr>
      <tr v-if="hasFilter">
        <th :colspan="tableHeaders.length">
          <div class="display-flex">
            <filter-cell
              v-for="h in tableFilters"
              :config="h"
              :value="filters[h.field]"
              @input="onFilter(h.field, $event)"
            />
          </div>
        </th>
      </tr>
    </tfoot>
  </table>
</template>
<script>
import Header from "./Header.vue";
import FilterCell from "./Filter.vue";
import {
  FILTER_EMPTY_ARRAY,
  FILTER_MULTI_SELECT,
  FILTER_TEXT_SEARCH,
} from "../../lib/constants";

export default {
  components: { Header, FilterCell },
  data() {
    return {
      direction: -1,
      sortColumnInternal: null,
      filtersInternal: {},
    };
  },
  props: {
    data: {
      type: Array,
      required: true,
    },
    headers: {
      type: Array,
      required: false,
      default: () => [],
    },
    headerConfig: {
      type: Array,
      required: false,
      default: () => [],
    },
  },
  computed: {
    filters() {
      return Object.fromEntries(
        this.headerConfigNormalized.map((x) => {
          if (this.filtersInternal[x.field]) {
            return [x.field, this.filtersInternal[x.field]];
          }
          return [x.field, []];
        })
      );
    },

    hasFilter() {
      return this.headerConfigNormalized.some((x) => x.filterType);
    },
    sortColumn() {
      return (
        this.sortColumnInternal ||
        this.headerConfig.find((x) => x.defaultSort)?.field ||
        this.headers[this.headers.length - 1]
      );
    },
    headerConfigNormalized() {
      if (this.headerConfig.length) {
        return this.headerConfig;
      }

      return this.headers.map((x) => {
        const text = x.charAt(0).toLocaleUpperCase() + x.slice(1);
        return { field: x, text, sortable: true };
      });
    },
    tableFilters() {
      return this.headerConfigNormalized.filter((x) => !!x.filterType);
    },
    tableHeaders() {
      const column = this.headerConfigNormalized.findIndex(
        (x) => this.sortColumn === x.field
      );

      const res = JSON.parse(JSON.stringify(this.headerConfigNormalized));

      if (column >= 0) {
        res[column] = {
          ...res[column],
          active: this.direction === -1 ? "down" : "up",
        };
      }

      return res;
    },
    filtered() {
      let candidates = [...this.data];
      const searches = Object.entries(this.filtersInternal);

      for (const [field, searchObject] of searches) {
        const fieldConfig = this.headerConfigNormalized.find(
          (x) => x.field === field
        );
        if (fieldConfig?.filterType === FILTER_MULTI_SELECT) {
          const searchValues = searchObject.map((x) => x.value);
          if (!searchValues.length) {
            continue;
          }
          candidates = candidates.filter((x) => {
            const val = x[field];

            if (Array.isArray(val)) {
              if (
                val.length === 0 &&
                searchValues.includes(FILTER_EMPTY_ARRAY)
              ) {
                return true;
              }
              return val.some((v) => searchValues.includes(v));
            }

            return searchValues.includes(val);
          });
        } else if (fieldConfig?.filterType === FILTER_TEXT_SEARCH) {
          const searchValue = (searchObject[0] || "").toLocaleLowerCase();
          if (!searchValue.length) {
            continue;
          }

          candidates = candidates.filter((x) => {
            const val = x[field];

            if (Array.isArray(val)) {
              return val.some((v) =>
                `${v || ""}`.toLocaleLowerCase().includes(searchValue)
              );
            }

            return `${val || ""}`.toLocaleLowerCase().includes(searchValue);
          });
        }
      }

      return candidates;
    },
    sorted() {
      if (!this.sortColumn) {
        return this.filtered;
      }
      return this.filtered.sort((aO, bO) => {
        const a = aO[this.sortColumn];
        const b = bO[this.sortColumn];
        if (Number.isFinite(a) && Number.isFinite(b)) {
          return (a - b) * this.direction;
        }
        return (
          (JSON.stringify(a) < JSON.stringify(b) ? -1 : 1) * this.direction
        );
      });
    },
  },
  methods: {
    onFilter(field, event) {
      this.filtersInternal = {
        ...this.filtersInternal,
        [field]: [...event],
      };
    },
    sort(column) {
      const { sortable, field } = column;
      if (!sortable) {
        return;
      }
      if (this.sortColumn === field) {
        this.direction = this.direction * -1;
      } else {
        this.sortColumnInternal = field;
        this.direction = -1;
      }
    },
  },
};
</script>
<style scoped>
tbody tr:nth-child(even) {
  background: #efefef;
}

tbody tr:nth-child(odd) {
  background: #fff;
}

tr td {
  padding: 0.5rem;
}

tr th {
  padding: 0.5rem;
  font-size: 1em;
  border: 0 solid darkslategray;
}

thead tr th {
  border-bottom-width: 1px;
}

tfoot tr th {
  border-top-width: 1px;
}

.display-flex {
  display: flex;
  width: 100%;
  flex-direction: column;
}
</style>
